/*
ABOUT:
Energy Grid
For www.Gamedev.net Physics contest

This game is used to make an example for newtons laws of motion, mainly momentom.

AUTHOR: Daniel Ostrander, Xero-X2
HELPER: Mickel Votaw

COMPILER:Borland C++ Builder 5
USES:OpenGL Api, DirectX 8.1, HEHE early lesson base code for window conrol, Custom design state AI, Custom low vertex and face only model loader, www.Gamedev.net frame rate independent movement.
CAR MODEL:EGX(Vehical) by Mickel Votaw Moded by Daniel Ostrander
*/

#include <windows.h>
#include <dmusicc.h>
#include <dmusici.h>
#include <d3d8types.h>
#include <utilcls.h>
#include <DMUtil.h>
#include <DXUtil.h>
#include <gl\gl.h>
#include <gl\glu.h>
#include <gl\glaux.h>
#include <stdio.h>
#include <math.h>
#include <math.hpp>
#include <stdio.h>
#include <stdarg.h>
#include <fstream.h>
#include <stdlib.h>
#include <vcl\registry.hpp>
#include <time.h>
#include <vcl.h>

USELIB("glaux.lib");
#pragma comment(lib,"dxguid.lib")
//---------------------------------------------------------------------------
#include "Subs\Varibles.h"
#include "Subs\Text.cpp"
#include "Subs\WindowControl.cpp"
#include "Subs\texture.cpp"
#include "Subs\AI.cpp"
#include "Subs\Sound.cpp"
#include "Subs\maingame.cpp"
//---------------------------------------------------------------------------\\


int InitGLMini(GLvoid)//OpenGl startup management
{
TimeUnit.Init(30);
        glEnable(GL_TEXTURE_2D);
	glShadeModel(GL_SMOOTH);
        glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
        glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);
        glEnable(GL_LINE_SMOOTH);
        glBlendFunc(GL_SRC_ALPHA,GL_ONE);

        
        CreateTexture(textures,"Data/Loading.bmp",0);
        CreateTexture(textures,"Data/EnergyBarrier.bmp",1);
        CreateTexture(textures,"Data/EnergyRipple.bmp",2);
        CreateTexture(textures,"Data/MENUTital.bmp",3);
        CreateTexture(textures,"Data/beam.bmp",4);

        LoadV();

        glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
glOrtho(0.0f,1,1,0.0f,-90.0f,90.0f);
	glMatrixMode(GL_MODELVIEW);
glBindTexture(GL_TEXTURE_2D, textures[0]);
glColor4ub(255,255,255,255);
glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
        glBegin(GL_QUADS);
		glTexCoord2f(0.0f,1.0f); glVertex3f(0, .2, 0);
	        glTexCoord2f(1.0f,1.0f); glVertex3f(1, .2, 0);
	        glTexCoord2f(1.0f,0.0f); glVertex3f(1, .8, 0);
		glTexCoord2f(0.0f,0.0f); glVertex3f(0, .8, 0);
        glEnd();
        SwapBuffers(hDC);
ReSizeGLScene( XMODE, YMODE);

//BuildFontBitmap();
BuildFont();
menuanimationcue=255;
game_state=state_fadeloading;

return TRUE;
}

int InitGL(GLvoid)//OpenGl startup management
{
TimeUnit.Init(30);
/*DIRECT MUSIC INIT*/
SoundSetup();
/*OPENGL INIT*/
        glEnable(GL_TEXTURE_2D);
	glShadeModel(GL_SMOOTH);
        glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
        glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);
        glEnable(GL_LINE_SMOOTH);
        glBlendFunc(GL_SRC_ALPHA,GL_ONE);

        CreateTexture(textures,"Data/Loading.bmp",0);
        CreateTexture(textures,"Data/EnergyBarrier.bmp",1);
        CreateTexture(textures,"Data/EnergyRipple.bmp",2);
        CreateTexture(textures,"Data/MENUTital.bmp",3);
        CreateTexture(textures,"Data/beam.bmp",4);

        LoadV();


glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
glOrtho(0.0f,1,1,0.0f,-90.0f,90.0f);
	glMatrixMode(GL_MODELVIEW);
glBindTexture(GL_TEXTURE_2D, textures[0]);
glColor4ub(255,255,255,255);
glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
        glBegin(GL_QUADS);
		glTexCoord2f(0.0f,1.0f); glVertex3f(0, .2, 0);
	        glTexCoord2f(1.0f,1.0f); glVertex3f(1, .2, 0);
	        glTexCoord2f(1.0f,0.0f); glVertex3f(1, .8, 0);
		glTexCoord2f(0.0f,0.0f); glVertex3f(0, .8, 0);
        glEnd();
        SwapBuffers(hDC);
ReSizeGLScene( XMODE, YMODE);

//BuildFontBitmap();
BuildFont();


//Map the Grid
GLfloat rate=360/divistions;
for (int q=0; q<divistions;q++)
{
GLfloat radius=DIAMETER/2;
grid[q][0].x=radius*cos(DegToRad(q*rate));
grid[q][0].y=radius*sin(DegToRad(q*rate));
grid[q][1].x=radius*cos(DegToRad(180-(q*rate)));
grid[q][1].y=radius*sin(DegToRad((180-(q*rate))));
Sgrid[q]=grid[q][0];
Sgrid[q+100]=grid[q][1];
}
PREPGAME();


//------------
virtualpoints.x=20;
virtualpoints.y=45;


scaninpersent=0;
pass=100;
menuanimationcue=255;

if (RECORDDEMO)
RECORD.open("New.Demo");
//-------------
return TRUE;
}


int DrawGLScene(GLvoid)//DRAW FUNCTION
{
TEST1=clock();
TIniFile *ini= new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
//ini->WriteFloat("Game","TIME", ((float)TEST1 - (float)TEST2) / (float)CLK_TCK);
delete ini;
TEST2=clock();


	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
        glLoadIdentity();
        glDisable(GL_BLEND);
        glEnable(GL_DEPTH_TEST);
       	glDepthFunc(GL_LEQUAL);
        glEnable(GL_TEXTURE_2D);
        glColor4ub(0,FADE*255,0,255);

if (game_state==state_fadeloading)
{
glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
glOrtho(0.0f,1,1,0.0f,-90.0f,90.0f);
glMatrixMode(GL_MODELVIEW);
glBindTexture(GL_TEXTURE_2D, textures[0]);
glColor4ub(menuanimationcue,menuanimationcue,menuanimationcue,255);
        glBegin(GL_QUADS);
		glTexCoord2f(0.0f,1.0f); glVertex3f(0, .2, 0);
	        glTexCoord2f(1.0f,1.0f); glVertex3f(1, .2, 0);
	        glTexCoord2f(1.0f,0.0f); glVertex3f(1, .8, 0);
		glTexCoord2f(0.0f,0.0f); glVertex3f(0, .8, 0);
        glEnd();
ReSizeGLScene( XMODE, YMODE);
}

if (game_state==state_scorescreen)
{
glMatrixMode(GL_PROJECTION);
glLoadIdentity();
glOrtho(0.0f,20,0,20.0f,-90.0f,90.0f);
glMatrixMode(GL_MODELVIEW);
glBindTexture(GL_TEXTURE_2D, 0);
glLoadIdentity();
glColor4ub(0,menuanimationcue,0,255);
glBegin(GL_LINES);
		glVertex3f(1, 16, 0);
	        glVertex3f(19, 16, 0);
                glVertex3f(1, 15, 0);
	        glVertex3f(19, 15, 0);
glEnd();
if (ROUND!=0)
{
glTranslatef(10,18,0);
glPrintcenter(("ROUND "+IntToStr(ROUND)).c_str());
glLoadIdentity();
}

glTranslatef(9.5,17,0);
glPrintLEFT("Player");
glLoadIdentity();
glTranslatef(9.5,16,0);
glPrintLEFT(IntToStr((int)(SCORE1*((float)menuanimationcue/255))).c_str());
glLoadIdentity();
glTranslatef(9.5,15,0);
glPrintLEFT(IntToStr((int)(ROUNDS1*((float)menuanimationcue/255))).c_str());
glLoadIdentity();
glTranslatef(10.5,17,0);
glPrintRIGHT("Computer");
glLoadIdentity();
glTranslatef(10.5,16,0);
glPrintRIGHT(IntToStr((int)(SCORE2*((float)menuanimationcue/255))).c_str());
glLoadIdentity();
glTranslatef(10.5,15,0);
glPrintRIGHT(IntToStr((int)(ROUNDS2*((float)menuanimationcue/255))).c_str());
glLoadIdentity();
glTranslatef(10,3,0);
glPrintcenter("(Press any key)");
ReSizeGLScene( XMODE, YMODE);
}

if (game_state==state_mainmenu||game_state==state_MAINMENUfadeout)
{
glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
glOrtho(0.0f,1,1,0.0f,-90.0f,90.0f);
glMatrixMode(GL_MODELVIEW);
glBindTexture(GL_TEXTURE_2D, textures[3]);
glColor4ub(menuanimationcue,menuanimationcue,menuanimationcue,255);
        glBegin(GL_QUADS);
		glTexCoord2f(0.0f,1.0f); glVertex3f(0, .0, 0);
	        glTexCoord2f(1.0f,1.0f); glVertex3f(1, .0, 0);
	        glTexCoord2f(1.0f,0.0f); glVertex3f(1, .3, 0);
		glTexCoord2f(0.0f,0.0f); glVertex3f(0, .3, 0);
        glEnd();
glMatrixMode(GL_PROJECTION);
glLoadIdentity();
glOrtho(0.0f,20,0,20.0f,-90.0f,90.0f);
glMatrixMode(GL_MODELVIEW);
glBindTexture(GL_TEXTURE_2D, 0);
glLoadIdentity();

glTranslatef(10,10,0);
if (optionselected==0)
glColor4ub(0,menuanimationcue,0,255);
else
glColor4ub(0,menuanimationcue/2,0,255);
glPrintcenter("Play");
          glLoadIdentity();
glTranslatef(10,8,0);
if (optionselected==1)
glColor4ub(0,menuanimationcue,0,255);
else
glColor4ub(0,menuanimationcue/2,0,255);
glPrintcenter("Options");
          glLoadIdentity();
glTranslatef(10,6,0);
if (optionselected==2)
glColor4ub(0,menuanimationcue,0,255);
else
glColor4ub(0,menuanimationcue/2,0,255);
glPrintcenter("Exit");

ReSizeGLScene( XMODE, YMODE);
}



if (game_state==state_optionsmenu||game_state==state_O_fade)
{
glMatrixMode(GL_PROJECTION);
glLoadIdentity();
glOrtho(0.0f,20,0,20.0f,-90.0f,90.0f);
glMatrixMode(GL_MODELVIEW);
glBindTexture(GL_TEXTURE_2D, 0);
glLoadIdentity();

glTranslatef(10,12,0);
if (optionselected==0)
glColor4ub(0,menuanimationcue,0,255);
else
glColor4ub(0,menuanimationcue/2,0,255);
glPrintcenter(((String)"Resolution="+XMODE+" by "+YMODE).c_str());
          glLoadIdentity();
glTranslatef(10,10,0);
if (optionselected==1)
glColor4ub(0,menuanimationcue,0,255);
else
glColor4ub(0,menuanimationcue/2,0,255);
glPrintcenter(((String)"Bits="+COLORBIT).c_str());
glLoadIdentity();
glTranslatef(10,8,0);
if (optionselected==2)
glColor4ub(0,menuanimationcue,0,255);
else
glColor4ub(0,menuanimationcue/2,0,255);
if (firstperson)
glPrintcenter("First Person");
else
glPrintcenter("Third Person");
          glLoadIdentity();
glTranslatef(10,6,0);
if (optionselected==3)
glColor4ub(0,menuanimationcue,0,255);
else
glColor4ub(0,menuanimationcue/2,0,255);
if (SOUND)
glPrintcenter("Sound is (on)");
else
glPrintcenter("Sound is (off)");
          glLoadIdentity();
glTranslatef(10,4,0);
if (optionselected==4)
glColor4ub(0,menuanimationcue,0,255);
else
glColor4ub(0,menuanimationcue/2,0,255);
glPrintcenter("Back");

//ReSizeGLScene( XMODE, YMODE);


}

if (game_state==state_playing || game_state==state_DEMO || game_state==state_P_fade || game_state==state_D_fade || game_state==state_P_fadein || game_state==state_D_fadein)
{
ReSizeGLScene( XMODE, YMODE);

glPushMatrix();
gluLookAt (0.0, 0.0, 0.0, 0.0, 0.0, -100.0, 0.0, 1.0, 0.0);
glTranslatef(0,0,-2.5);
if (scaninpersent==150)
playAi("beep.wav");
if (scaninpersent==200)
playAi("beep.wav");
if (scaninpersent==250)
playAi("beep.wav");
if (scaninpersent==280)
playAi("beep.wav");
if(scaninpersent>150)
if(scaninpersent<200)
{
glTranslatef(0,0,-scaninpersent+150);
glPrintcenter("1/3");
}
if(scaninpersent>200)
if(scaninpersent<250)
{
glTranslatef(0,0,-scaninpersent+200);
glPrintcenter("2/3");
}
if(scaninpersent>250)
if(scaninpersent<280)
{
glTranslatef(0,0,-scaninpersent+250);
glPrintcenter("3/3");
}
if(scaninpersent>280)
if(scaninpersent<300)
{
glTranslatef(0,0,-scaninpersent+280);
glPrintcenter("GO!");
}
glPopMatrix();


DVector temp;
if (!firstperson)
{
temp.Length=-.005;
temp.SetAngle(mLoc.Rotation);
}
if (game_state==state_DEMO || game_state==state_D_fade || game_state==state_D_fadein)
{
scaninpersent=301;
gluLookAt (0.0, 0.0, 0.0, 0.0, 0.0, -100.0, 0.0, 1.0, 0.0);
glTranslatef(0,0,-DIAMETER/1.1);
glRotatef(virtualpoints.x/2,1,0,0);
glRotatef(virtualpoints.y,0,1,0);
glRotatef((float)position/24,0,1,0);
}

if (!firstperson)
{
if (game_state==state_playing || game_state==state_P_fade || game_state==state_P_fadein)
if (scaninpersent>300)
{
glTranslatef(0,0,-20);
if (camera)
gluLookAt(temp.X+oLoc.X, .201, temp.Y+oLoc.Y, oLoc.X, .2, oLoc.Y, 0, 1, 0);
else
gluLookAt(temp.X+mLoc.X, .201, temp.Y+mLoc.Y, mLoc.X, .2, mLoc.Y, 0, 1, 0);
}
else
{
gluLookAt (0.0, 0.0, 0.0, 0.0, 0.0, -100.0, 0.0, 1.0, 0.0);
glTranslatef(0,0,-DIAMETER);
glRotatef(virtualpoints.x,1,0,0);
glRotatef(virtualpoints.y,0,1,0);
}
}
else
{
if (game_state==state_playing || game_state==state_P_fade || game_state==state_P_fadein)
gluLookAt (0.0, 0.0, 0.0, 0.0, 0.0, -100.0, 0.0, 1.0, 0.0);
if (game_state==state_playing || game_state==state_P_fade || game_state==state_P_fadein)
if (scaninpersent>300)
{
glRotatef(mLoc.Rotation+90,0,1,0);
glTranslatef(-mLoc.X,-.5,-mLoc.Y);
}
else
{
glTranslatef(0,0,-DIAMETER);
glRotatef(virtualpoints.x,1,0,0);
glRotatef(virtualpoints.y,0,1,0);

}
}


glPushMatrix();
glTranslatef(mLoc.X,.1,mLoc.Y);

if (scaninpersent>300)
{
glRotatef(-mLoc.Rotation+90,0,1,0);
if (firstperson)
drawVX();
else
drawV(false);


glPopMatrix();
}
glPushMatrix();
glTranslatef(oLoc.X,.1,oLoc.Y);

if (scaninpersent>300)
{
glRotatef(-oLoc.Rotation+90,0,1,0);
drawV(true);
}

glPopMatrix();




staa Vertex;Vertex.x=mLoc.X;Vertex.y=mLoc.Y;
staa Vertex2;Vertex2.x=oLoc.X;Vertex2.y=oLoc.Y;
DrawGrid(!VertexInside(Vertex,Vertex2,1.5,DIAMETER));

}
return TRUE;
}


LRESULT CALLBACK WndProc(	HWND	hWnd,
							UINT	uMsg,
							WPARAM	wParam,
							LPARAM	lParam)
{
	switch (uMsg)
	{
		case WM_ACTIVATE:
		{
			if (!HIWORD(wParam))
			{
				active=TRUE;
			}
			else
			{
				active=FALSE;
			}

			return 0;
		}

		case WM_SYSCOMMAND:
		{
			switch (wParam)
			{
				case SC_SCREENSAVE:
				case SC_MONITORPOWER:
				return 0;
			}
			break;
		}

		case WM_CLOSE:
		{
			PostQuitMessage(0);
			return 0;
		}
		case WM_KEYDOWN:
		{
                if (game_state==state_scorescreen)
                game_state=state_playing;
                if (game_state==state_DEMO)
                {
                game_state=state_D_fade;
                PLAYBACK->Clear();
                }


			keys[wParam] = TRUE;
			return 0;
		}

		case WM_KEYUP:
		{
			keys[wParam] = FALSE;
			return 0;
		}
                                case WM_LBUTTONDOWN:
                {
                MOUSELB=true;
                return 0;
                }
                case WM_RBUTTONDOWN:
                {
                if (game_state==state_scorescreen)
                game_state=state_playing;

                if (game_state==state_DEMO)
                {
                game_state=state_D_fade;
                //PLAYBACK->Clear();//fclose(PLAYBACK);
                }
                MOUSERB=true;
                return 0;
                }
                case WM_LBUTTONUP:
                {
                if (game_state==state_scorescreen)
                game_state=state_playing;
                if (game_state==state_DEMO)
                {
                game_state=state_D_fade;
                //PLAYBACK->Clear();
                }
                MOUSELB=false;
                return 0;
                }
                case WM_RBUTTONUP:
                {
                if (game_state==state_scorescreen)
                game_state=state_playing;
                if (game_state==state_DEMO)
                {
                game_state=state_D_fade;
                //PLAYBACK->Clear();
                //fclose(PLAYBACK);
                }
                MOUSERB=false;
                return 0;
                }
		case WM_SIZE:
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));
			return 0;
		}
	}


	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}


int WINAPI WinMain(	HINSTANCE	hInstance,
					HINSTANCE	hPrevInstance,
					LPSTR		lpCmdLine,
					int			nCmdShow)
{
	MSG		msg;
done=FALSE;



TIniFile *ini= new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
//SETTINGS LOADUP
FRAMERATEDISPLAY=ini->ReadBool("DEBUG","Show FPS", false);
XMODE=ini->ReadInteger("Display","X", 640);
YMODE=ini->ReadInteger("Display","Y", 480);
COLORBIT=ini->ReadInteger("Display","Bit", 16);
fullscreen=ini->ReadBool("Display","MODE", true);
DIAMETER=ini->ReadInteger("Game","Gridsize", 100);
divistions=ini->ReadInteger("Game","divistions", 40);
EDGEHEIGHT=ini->ReadInteger("Game","BoarderHeight", 2);
firstperson=ini->ReadInteger("Game","CAMERA", false);
SOUND=ini->ReadBool("Game","SOUND", true);
TIMEBASE=ini->ReadFloat("Game","TIME", .019);
RINGBASE=ini->ReadFloat("Game","RING", .0000001);//0.0001
delete ini;



if (!done)
{

	if (!CreateGLWindow("Energy Grid",XMODE,YMODE,COLORBIT,fullscreen))
        return 0;

	while(!done)
	{



		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
		{
			if (msg.message==WM_QUIT)
			{
				done=TRUE;
			}
			else
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
		else
		{

TimeUnit.SetSpeedFactor();
			if ((active && !DrawGLScene()))
			{
				done=TRUE;
			}
			else
                        {

LOADFADEE=clock();
if (game_state==state_fadeloading)
if ( ((float)LOADFADEE - (float)LOADFADE) / (float)CLK_TCK >= 0.0000001)
{
LOADFADE=clock();
menuanimationcue=menuanimationcue-4;
if (menuanimationcue<2)
game_state=state_mainmenu;
}

Rungame();


StFIXEND=clock();
if ( (((float)StFIXEND - (float)StFIX) / (float)CLK_TCK) >= RINGBASE)
{
StFIX=clock();
Change();
}

                        }

		}



	}


if (RECORDDEMO)
RECORD.close();

        delete(&mpos);
	KillGLWindow();
        }
	return (msg.wParam);
}
